import 'dart:convert';
import 'package:api_package/src/build_response.dart';
import 'package:shelf/shelf.dart';

abstract class ApiData {
  Response build({Duration? cache, String? etag}) => buildResponse(
    statusCode: 200,
    body: jsonEncode(this.toJson()),
    cache: cache,
    etag: etag,
  );

  Map<String, dynamic> toJson();
}

extension ListExtension<T extends ApiData> on List<T> {
  List<Map<String, dynamic>> toJson() {
    return cast<ApiData>().map((ApiData data) => data.toJson()).toList();
  }

  Response build({Duration? cache, String? etag}) => buildResponse(
    statusCode: 200,
    body: jsonEncode(this.toJson()),
    cache: cache,
    etag: etag
  );
}