import 'dart:io';
import 'package:shelf/shelf.dart';

Response buildResponse(
    {required int statusCode,
    required String body,
    required Duration? cache,
    String? etag}) {
  Map<String, String> headers = {
    HttpHeaders.contentTypeHeader: "application/json",
    HttpHeaders.cacheControlHeader:
        cache == null ? "no-cache" : "max-age=${cache.inSeconds}",
  };
  if (etag != null) headers[HttpHeaders.etagHeader] = etag;
  return Response(
    statusCode,
    body: body,
    headers: headers,
  );
}
